#include "LTR212StdFilters.h"

namespace LQMeas {


    static const unsigned short fir_coefs_d40_f25[229] = {
            0x0002, 0x0002, 0x0003, 0x0003, 0x0004, 0x0004, 0x0005, 0x0006, 0x0006, 0x0007,
            0x0008, 0x0009, 0x000A, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F, 0x0011, 0x0012,
            0x0014, 0x0015, 0x0017, 0x0019, 0x001A, 0x001C, 0x001E, 0x0020, 0x0022, 0x0024,
            0x0027, 0x0029, 0x002B, 0x002E, 0x0030, 0x0033, 0x0036, 0x0039, 0x003C, 0x003F,
            0x0042, 0x0045, 0x0048, 0x004B, 0x004F, 0x0052, 0x0056, 0x0059, 0x005D, 0x0061,
            0x0065, 0x0069, 0x006D, 0x0071, 0x0075, 0x0079, 0x007D, 0x0081, 0x0086, 0x008A,
            0x008E, 0x0093, 0x0097, 0x009B, 0x00A0, 0x00A4, 0x00A9, 0x00AD, 0x00B2, 0x00B6,
            0x00BB, 0x00BF, 0x00C4, 0x00C8, 0x00CD, 0x00D1, 0x00D6, 0x00DA, 0x00DE, 0x00E2,
            0x00E7, 0x00EB, 0x00EF, 0x00F3, 0x00F7, 0x00FB, 0x00FF, 0x0102, 0x0106, 0x0109,
            0x010D, 0x0110, 0x0113, 0x0116, 0x0119, 0x011C, 0x011F, 0x0121, 0x0124, 0x0126,
            0x0129, 0x012B, 0x012D, 0x012E, 0x0130, 0x0131, 0x0133, 0x0134, 0x0135, 0x0136,
            0x0137, 0x0137, 0x0137, 0x0138, 0x0138, 0x0138, 0x0137, 0x0137, 0x0137, 0x0136,
            0x0135, 0x0134, 0x0133, 0x0131, 0x0130, 0x012E, 0x012D, 0x012B, 0x0129, 0x0126,
            0x0124, 0x0121, 0x011F, 0x011C, 0x0119, 0x0116, 0x0113, 0x0110, 0x010D, 0x0109,
            0x0106, 0x0102, 0x00FF, 0x00FB, 0x00F7, 0x00F3, 0x00EF, 0x00EB, 0x00E7, 0x00E2,
            0x00DE, 0x00DA, 0x00D6, 0x00D1, 0x00CD, 0x00C8, 0x00C4, 0x00BF, 0x00BB, 0x00B6,
            0x00B2, 0x00AD, 0x00A9, 0x00A4, 0x00A0, 0x009B, 0x0097, 0x0093, 0x008E, 0x008A,
            0x0086, 0x0081, 0x007D, 0x0079, 0x0075, 0x0071, 0x006D, 0x0069, 0x0065, 0x0061,
            0x005D, 0x0059, 0x0056, 0x0052, 0x004F, 0x004B, 0x0048, 0x0045, 0x0042, 0x003F,
            0x003C, 0x0039, 0x0036, 0x0033, 0x0030, 0x002E, 0x002B, 0x0029, 0x0027, 0x0024,
            0x0022, 0x0020, 0x001E, 0x001C, 0x001A, 0x0019, 0x0017, 0x0015, 0x0014, 0x0012,
            0x0011, 0x000F, 0x000E, 0x000D, 0x000C, 0x000B, 0x000A, 0x0009, 0x0008, 0x0007,
            0x0006, 0x0006, 0x0005, 0x0004, 0x0004, 0x0003, 0x0003, 0x0002, 0x0002
    };
    const LTR212Filter &LTR212StdFilters::fir_d40_f25() {
        static const LTR212Filter flt(QStringLiteral("fir_d40_f25"), 40, fir_coefs_d40_f25, 229, 25., false);
        return flt;
    }

    static const unsigned short fir_coefs_d24_f70[225] = {
        0x0001, 0x0001, 0x0001, 0x0001, 0x0002, 0x0002, 0x0002, 0x0002, 0x0003, 0x0003,
        0x0003, 0x0003, 0x0003, 0x0003, 0x0004, 0x0004, 0x0004, 0x0003, 0x0003, 0x0003,
        0x0003, 0x0002, 0x0001, 0x0001, 0x0000, 0x0000, 0xFFFF, 0xFFFD, 0xFFFC, 0xFFFA,
        0xFFF8, 0xFFF6, 0xFFF4, 0xFFF2, 0xFFF0, 0xFFED, 0xFFEA, 0xFFE8, 0xFFE5, 0xFFE2,
        0xFFDF, 0xFFDC, 0xFFD9, 0xFFD6, 0xFFD3, 0xFFD0, 0xFFCD, 0xFFCA, 0xFFC8, 0xFFC5,
        0xFFC3, 0xFFC2, 0xFFC0, 0xFFBF, 0xFFBF, 0xFFBF, 0xFFC0, 0xFFC1, 0xFFC2, 0xFFC5,
        0xFFC8, 0xFFCC, 0xFFD1, 0xFFD6, 0xFFDC, 0xFFE4, 0xFFEC, 0xFFF5, 0xFFFF, 0x0009,
        0x0015, 0x0022, 0x0030, 0x003F, 0x004E, 0x005F, 0x0071, 0x0083, 0x0096, 0x00AA,
        0x00BF, 0x00D4, 0x00EA, 0x0101, 0x0118, 0x012F, 0x0146, 0x015E, 0x0176, 0x018E,
        0x01A6, 0x01BE, 0x01D5, 0x01EC, 0x0203, 0x0219, 0x022E, 0x0243, 0x0257, 0x026A,
        0x027C, 0x028D, 0x029C, 0x02AB, 0x02B8, 0x02C3, 0x02CE, 0x02D6, 0x02DE, 0x02E3,
        0x02E7, 0x02EA, 0x02EA, 0x02EA, 0x02E7, 0x02E3, 0x02DE, 0x02D6, 0x02CE, 0x02C3,
        0x02B8, 0x02AB, 0x029C, 0x028D, 0x027C, 0x026A, 0x0257, 0x0243, 0x022E, 0x0219,
        0x0203, 0x01EC, 0x01D5, 0x01BE, 0x01A6, 0x018E, 0x0176, 0x015E, 0x0146, 0x012F,
        0x0118, 0x0101, 0x00EA, 0x00D4, 0x00BF, 0x00AA, 0x0096, 0x0083, 0x0071, 0x005F,
        0x004E, 0x003F, 0x0030, 0x0022, 0x0015, 0x0009, 0xFFFF, 0xFFF5, 0xFFEC, 0xFFE4,
        0xFFDC, 0xFFD6, 0xFFD1, 0xFFCC, 0xFFC8, 0xFFC5, 0xFFC2, 0xFFC1, 0xFFC0, 0xFFBF,
        0xFFBF, 0xFFBF, 0xFFC0, 0xFFC2, 0xFFC3, 0xFFC5, 0xFFC8, 0xFFCA, 0xFFCD, 0xFFD0,
        0xFFD3, 0xFFD6, 0xFFD9, 0xFFDC, 0xFFDF, 0xFFE2, 0xFFE5, 0xFFE8, 0xFFEA, 0xFFED,
        0xFFF0, 0xFFF2, 0xFFF4, 0xFFF6, 0xFFF8, 0xFFFA, 0xFFFC, 0xFFFD, 0xFFFF, 0x0000,
        0x0000, 0x0001, 0x0001, 0x0002, 0x0003, 0x0003, 0x0003, 0x0003, 0x0004, 0x0004,
        0x0004, 0x0003, 0x0003, 0x0003, 0x0003, 0x0003, 0x0003, 0x0002, 0x0002, 0x0002,
        0x0002, 0x0001, 0x0001, 0x0001, 0x0001
    };
    const LTR212Filter &LTR212StdFilters::fir_d24_f70() {
        static const LTR212Filter flt(QStringLiteral("fir_d24_f70"), 24, fir_coefs_d24_f70, 225, 70., false);
        return flt;
    }

    static const unsigned short fir_coefs_d11_f258[217] = {
        0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFF,
        0x0000, 0x0000, 0x0002, 0x0003, 0x0005, 0x0007, 0x0008, 0x0009, 0x000A, 0x000A,
        0x000A, 0x0009, 0x0007, 0x0004, 0x0001, 0xFFFE, 0xFFFA, 0xFFF5, 0xFFF1, 0xFFED,
        0xFFE9, 0xFFE6, 0xFFE5, 0xFFE5, 0xFFE7, 0xFFEA, 0xFFEF, 0xFFF5, 0xFFFE, 0x0006,
        0x0010, 0x001A, 0x0024, 0x002D, 0x0034, 0x0039, 0x003C, 0x003B, 0x0037, 0x002F,
        0x0024, 0x0016, 0x0004, 0xFFF2, 0xFFDE, 0xFFC9, 0xFFB6, 0xFFA5, 0xFF97, 0xFF8D,
        0xFF8A, 0xFF8C, 0xFF95, 0xFFA5, 0xFFBC, 0xFFD8, 0xFFF9, 0x001E, 0x0044, 0x006B,
        0x0090, 0x00B0, 0x00CA, 0x00DB, 0x00E1, 0x00DC, 0x00CA, 0x00AB, 0x0080, 0x0049,
        0x0009, 0xFFC2, 0xFF76, 0xFF29, 0xFEE0, 0xFE9E, 0xFE69, 0xFE43, 0xFE32, 0xFE38,
        0xFE58, 0xFE94, 0xFEEE, 0xFF64, 0xFFF6, 0x00A0, 0x0162, 0x0235, 0x0314, 0x03FA,
        0x04E0, 0x05BF, 0x0691, 0x0750, 0x07F4, 0x087A, 0x08DD, 0x091A, 0x092E, 0x091A,
        0x08DD, 0x087A, 0x07F4, 0x0750, 0x0691, 0x05BF, 0x04E0, 0x03FA, 0x0314, 0x0235,
        0x0162, 0x00A0, 0xFFF6, 0xFF64, 0xFEEE, 0xFE94, 0xFE58, 0xFE38, 0xFE32, 0xFE43,
        0xFE69, 0xFE9E, 0xFEE0, 0xFF29, 0xFF76, 0xFFC2, 0x0009, 0x0049, 0x0080, 0x00AB,
        0x00CA, 0x00DC, 0x00E1, 0x00DB, 0x00CA, 0x00B0, 0x0090, 0x006B, 0x0044, 0x001E,
        0xFFF9, 0xFFD8, 0xFFBC, 0xFFA5, 0xFF95, 0xFF8C, 0xFF8A, 0xFF8D, 0xFF97, 0xFFA5,
        0xFFB6, 0xFFC9, 0xFFDE, 0xFFF2, 0x0004, 0x0016, 0x0024, 0x002F, 0x0037, 0x003B,
        0x003C, 0x0039, 0x0034, 0x002D, 0x0024, 0x001A, 0x0010, 0x0006, 0xFFFE, 0xFFF5,
        0xFFEF, 0xFFEA, 0xFFE7, 0xFFE5, 0xFFE5, 0xFFE6, 0xFFE9, 0xFFED, 0xFFF1, 0xFFF5,
        0xFFFA, 0xFFFE, 0x0001, 0x0004, 0x0007, 0x0009, 0x000A, 0x000A, 0x000A, 0x0009,
        0x0008, 0x0007, 0x0005, 0x0003, 0x0002, 0x0000, 0x0000, 0xFFFF, 0xFFFE, 0xFFFE,
        0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF
    };
    const LTR212Filter &LTR212StdFilters::fir_d11_f258() {
        static const LTR212Filter flt(QStringLiteral("fir_d11_f258"), 11, fir_coefs_d11_f258, 217, 258., false);
        return flt;
    }

    static const unsigned short fir_coefs_d7_f456[221] = {
        0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0001, 0x0002, 0x0003, 0x0004,
        0x0004, 0x0004, 0x0002, 0x0000, 0xFFFE, 0xFFFC, 0xFFF9, 0xFFF7, 0xFFF7, 0xFFF8,
        0xFFFB, 0xFFFF, 0x0003, 0x0008, 0x000D, 0x0010, 0x0011, 0x000F, 0x000A, 0x0003,
        0xFFFB, 0xFFF2, 0xFFEA, 0xFFE5, 0xFFE4, 0xFFE7, 0xFFEF, 0xFFFA, 0x0007, 0x0016,
        0x0022, 0x002B, 0x002D, 0x0028, 0x001C, 0x000A, 0xFFF6, 0xFFDF, 0xFFCC, 0xFFBF,
        0xFFBC, 0xFFC3, 0xFFD4, 0xFFEF, 0x000E, 0x002F, 0x004B, 0x005F, 0x0065, 0x005B,
        0x0042, 0x001C, 0xFFEF, 0xFFBF, 0xFF95, 0xFF78, 0xFF6E, 0xFF7A, 0xFF9D, 0xFFD3,
        0x0015, 0x005A, 0x0097, 0x00C2, 0x00D2, 0x00C2, 0x0092, 0x0046, 0xFFE8, 0xFF84,
        0xFF29, 0xFEE8, 0xFECD, 0xFEE0, 0xFF23, 0xFF90, 0x001B, 0x00B1, 0x013D, 0x01A7,
        0x01D9, 0x01C5, 0x0166, 0x00C0, 0xFFE3, 0xFEE9, 0xFDF5, 0xFD2E, 0xFCB9, 0xFCB9,
        0xFD46, 0xFE6A, 0x001E, 0x024F, 0x04D8, 0x0786, 0x0A24, 0x0C78, 0x0E4D, 0x0F78,
        0x0FDF, 0x0F78, 0x0E4D, 0x0C78, 0x0A24, 0x0786, 0x04D8, 0x024F, 0x001E, 0xFE6A,
        0xFD46, 0xFCB9, 0xFCB9, 0xFD2E, 0xFDF5, 0xFEE9, 0xFFE3, 0x00C0, 0x0166, 0x01C5,
        0x01D9, 0x01A7, 0x013D, 0x00B1, 0x001B, 0xFF90, 0xFF23, 0xFEE0, 0xFECD, 0xFEE8,
        0xFF29, 0xFF84, 0xFFE8, 0x0046, 0x0092, 0x00C2, 0x00D2, 0x00C2, 0x0097, 0x005A,
        0x0015, 0xFFD3, 0xFF9D, 0xFF7A, 0xFF6E, 0xFF78, 0xFF95, 0xFFBF, 0xFFEF, 0x001C,
        0x0042, 0x005B, 0x0065, 0x005F, 0x004B, 0x002F, 0x000E, 0xFFEF, 0xFFD4, 0xFFC3,
        0xFFBC, 0xFFBF, 0xFFCC, 0xFFDF, 0xFFF6, 0x000A, 0x001C, 0x0028, 0x002D, 0x002B,
        0x0022, 0x0016, 0x0007, 0xFFFA, 0xFFEF, 0xFFE7, 0xFFE4, 0xFFE5, 0xFFEA, 0xFFF2,
        0xFFFB, 0x0003, 0x000A, 0x000F, 0x0011, 0x0010, 0x000D, 0x0008, 0x0003, 0xFFFF,
        0xFFFB, 0xFFF8, 0xFFF7, 0xFFF7, 0xFFF9, 0xFFFC, 0xFFFE, 0x0000, 0x0002, 0x0004,
        0x0004, 0x0004, 0x0003, 0x0002, 0x0001, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
        0xFFFF
    };
    const LTR212Filter &LTR212StdFilters::fir_d7_f456() {
        static const LTR212Filter flt(QStringLiteral("fir_d7_f456"), 7, fir_coefs_d7_f456, 221, 456., false);
        return flt;
    }

    static const unsigned short fir_coefs_d7_f675[229] = {
        0x0001, 0x0001, 0x0001, 0x0000, 0x0000, 0xFFFF, 0xFFFE, 0xFFFD, 0xFFFE, 0x0000,
        0x0001, 0x0003, 0x0005, 0x0004, 0x0002, 0x0000, 0xFFFC, 0xFFF9, 0xFFF8, 0xFFFA,
        0xFFFE, 0x0003, 0x0009, 0x000C, 0x000B, 0x0006, 0xFFFF, 0xFFF7, 0xFFF0, 0xFFEE,
        0xFFF2, 0xFFFC, 0x0007, 0x0013, 0x0019, 0x0018, 0x000E, 0xFFFF, 0xFFEE, 0xFFE1,
        0xFFDD, 0xFFE5, 0xFFF7, 0x000E, 0x0023, 0x002E, 0x002C, 0x0019, 0xFFFE, 0xFFDF,
        0xFFC8, 0xFFC2, 0xFFD0, 0xFFF0, 0x0017, 0x003C, 0x0050, 0x004B, 0x002C, 0xFFFD,
        0xFFC9, 0xFFA2, 0xFF98, 0xFFAF, 0xFFE4, 0x0026, 0x0062, 0x0083, 0x007C, 0x004A,
        0xFFFB, 0xFFA7, 0xFF68, 0xFF56, 0xFF7C, 0xFFD1, 0x003C, 0x009F, 0x00D5, 0x00CA,
        0x007A, 0xFFFA, 0xFF70, 0xFF08, 0xFEE9, 0xFF24, 0xFFAF, 0x0062, 0x0108, 0x0167,
        0x0158, 0x00D3, 0xFFF9, 0xFF08, 0xFE4C, 0xFE0D, 0xFE6E, 0xFF66, 0x00B4, 0x01F8,
        0x02C2, 0x02BB, 0x01C0, 0xFFF9, 0xFDD3, 0xFBF2, 0xFB0A, 0xFBAC, 0xFE22, 0x024F,
        0x07B0, 0x0D6A, 0x127E, 0x15FD, 0x173C, 0x15FD, 0x127E, 0x0D6A, 0x07B0, 0x024F,
        0xFE22, 0xFBAC, 0xFB0A, 0xFBF2, 0xFDD3, 0xFFF9, 0x01C0, 0x02BB, 0x02C2, 0x01F8,
        0x00B4, 0xFF66, 0xFE6E, 0xFE0D, 0xFE4C, 0xFF08, 0xFFF9, 0x00D3, 0x0158, 0x0167,
        0x0108, 0x0062, 0xFFAF, 0xFF24, 0xFEE9, 0xFF08, 0xFF70, 0xFFFA, 0x007A, 0x00CA,
        0x00D5, 0x009F, 0x003C, 0xFFD1, 0xFF7C, 0xFF56, 0xFF68, 0xFFA7, 0xFFFB, 0x004A,
        0x007C, 0x0083, 0x0062, 0x0026, 0xFFE4, 0xFFAF, 0xFF98, 0xFFA2, 0xFFC9, 0xFFFD,
        0x002C, 0x004B, 0x0050, 0x003C, 0x0017, 0xFFF0, 0xFFD0, 0xFFC2, 0xFFC8, 0xFFDF,
        0xFFFE, 0x0019, 0x002C, 0x002E, 0x0023, 0x000E, 0xFFF7, 0xFFE5, 0xFFDD, 0xFFE1,
        0xFFEE, 0xFFFF, 0x000E, 0x0018, 0x0019, 0x0013, 0x0007, 0xFFFC, 0xFFF2, 0xFFEE,
        0xFFF0, 0xFFF7, 0xFFFF, 0x0006, 0x000B, 0x000C, 0x0009, 0x0003, 0xFFFE, 0xFFFA,
        0xFFF8, 0xFFF9, 0xFFFC, 0x0000, 0x0002, 0x0004, 0x0005, 0x0003, 0x0001, 0x0000,
        0xFFFE, 0xFFFD, 0xFFFE, 0xFFFF, 0x0000, 0x0000, 0x0001, 0x0001, 0x0001
    };
    const LTR212Filter &LTR212StdFilters::fir_d5_f675() {
        static const LTR212Filter flt(QStringLiteral("fir_d5_f675"), 5, fir_coefs_d7_f675, 229, 675., false);
        return flt;
    }

    static const unsigned short iir_coefs[5] = {
        0x5482, 0x5B97, 0x167C, 0xD194, 0xE7E7
    };
    const LTR212Filter &LTR212StdFilters::iirDefault() {
        static const LTR212Filter flt(QStringLiteral("iir_default"), 1, iir_coefs, 5, -1, true);
        return flt;
    }

    const QList<const LTR212Filter *> &LTR212StdFilters::firFilterList() {
        static const QList<const LTR212Filter *> list {
            &fir_d40_f25(),
            &fir_d24_f70(),
            &fir_d11_f258(),
            &fir_d7_f456(),
            &fir_d5_f675()
        };
        return list;
    }
}
